﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using ThinkGeo.Core;

namespace Demo
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // --------------following code will get the 3857 directly  ----------------
            map.MapUnit = GeographyUnit.Meter;
            map.MapTools.PanZoomBar.GlobeButtonVisibility = System.Windows.Visibility.Hidden;
            LayerOverlay layerOverlay = new LayerOverlay();
            WmsRasterLayer wmsLayer = new WmsRasterLayer(new Uri("http://www.gds-srv.hessen.de/cgi-bin/lika-services///ogc-free-maps.ows?language=ger&"));
            wmsLayer.ActiveLayerNames.Add("adv_alk");
            wmsLayer.Parameters.Add("transparent", "true");
            wmsLayer.Crs = String.Format("EPSG:{0}", 3857);
            wmsLayer.OutputFormat = "image/png";
            wmsLayer.Exceptions = "INIMAGE";
            wmsLayer.SendingWebRequest += WmsLayer_SendingWebRequest;
            layerOverlay.Layers.Add(wmsLayer);
            layerOverlay.TileType = TileType.SingleTile;
            map.Overlays.Add(layerOverlay);
            wmsLayer.Open();
            map.CurrentExtent = new RectangleShape(962134, 6470399.2, 962419.3, 6470150.1);// wmsLayer.GetBoundingBox();;
            map.Refresh();


            // --------------following code will get the 25832 and covert to 3857   ----------------
            //map.MapUnit = GeographyUnit.Meter;
            //map.MapTools.PanZoomBar.GlobeButtonVisibility = System.Windows.Visibility.Hidden;
            //LayerOverlay layerOverlay = new LayerOverlay();
            //WmsRasterLayer wmsLayer = new WmsRasterLayer(new Uri("http://www.gds-srv.hessen.de/cgi-bin/lika-services///ogc-free-maps.ows?language=ger&"));
            //wmsLayer.ActiveLayerNames.Add("adv_alk");
            //wmsLayer.Parameters.Add("transparent", "true");
            //wmsLayer.Crs = String.Format("EPSG:{0}", 25832);
            //wmsLayer.OutputFormat = "image/png";
            //wmsLayer.Exceptions = "INIMAGE";
            //wmsLayer.ImageSource.ProjectionConverter = new UnmanagedProjectionConverter(25832, 3857);
            //wmsLayer.SendingWebRequest += WmsLayer_SendingWebRequest;
            //layerOverlay.Layers.Add(wmsLayer);
            //layerOverlay.TileType = TileType.SingleTile;
            //map.Overlays.Add(layerOverlay);
            //wmsLayer.Open();
            //map.CurrentExtent = new RectangleShape(962134, 6470399.2, 962419.3, 6470150.1);// wmsLayer.GetBoundingBox();;
            //map.Refresh();
        }

        private void WmsLayer_SendingWebRequest(object sender, SendingWebRequestEventArgs e)
        {
            System.Diagnostics.Trace.WriteLine(e.WebRequest.RequestUri.ToString());
        }
    }
}
